/**
	AOK Trigger Studio (See aokts.cpp for legal conditions.)
	WINDOWS VERSION.

	utilunit.h: Declares various utility functions for units management.

	Note: windows.h must be included before this file.
**/

#ifndef UTILUNIT_H
#define UTILUNIT_H

/** Sorting **/

#define NUM_SORTS	2
enum Sorts
{
	SORT_ID,
	SORT_Name
};
extern char *sorts[NUM_SORTS];

/** Utility Functions **/

/* This structure should be passed as the lParam of the dialog function. */
struct UnitEdit
{
	char player;	// If equal to -1, the dialog will find out itself. Otherwise, EC numbering.
	short count;
	unsigned long ids[MAX_UNITSEL];
};

/*
	UnitList_Fill: Resets, then fills a unit listbox with data from an array of Unit structs.
*/
void UnitList_Fill(HWND listbox,		/* The listbox to fill. */
				   enum Sorts sorttype,
				   const class Unit *list, unsigned count);

/*
	UnitList_InsertItem: Inserts a new item in the listbox (in sort order)
		and returns its position.
*/
int UnitList_InsertItem(HWND listbox, enum Sorts sorttype,
						const class Unit *list, unsigned count, const class Unit *which);

/*
	UnitList_FillGroup: Fills a listbox with units in a group. Pass NULL as group
		to load all units.
*/
void UnitList_FillGroup(HWND typebox, class UnitGroupLink *group);

/* Selector Dialog */

INT_PTR WINAPI SelDlgProc(HWND dialog, UINT msg, WPARAM wParam, LPARAM lParam);
void LoadList(HWND dialog);
void SaveList(HWND dialog);

#endif	//UTILUNIT_H
